Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/Advanced/InstallationManager.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/Advanced/InstallationManager.cs	(revision 2516)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/Advanced/InstallationManager.cs	(revision 2517)
@@ -5,12 +5,24 @@
 using HeuristicLab.PluginInfrastructure.Manager;
 using System.IO;
+using System.ComponentModel;
+using HeuristicLab.PluginInfrastructure.UpdateLocationReference;
 
 namespace HeuristicLab.PluginInfrastructure.Advanced {
-  public class InstallationManager {
+  internal class InstallationManager {
+
+    internal event EventHandler<PluginInfrastructureCancelEventArgs> PreUpdatePlugin;
+    internal event EventHandler<PluginInfrastructureCancelEventArgs> PreRemovePlugin;
+    internal event EventHandler<PluginInfrastructureCancelEventArgs> PreInstallPlugin;
+
+    internal event EventHandler<PluginInfrastructureEventArgs> PluginUpdated;
+    internal event EventHandler<PluginInfrastructureEventArgs> PluginRemoved;
+    internal event EventHandler<PluginInfrastructureEventArgs> PluginInstalled;
 
     private string pluginDir;
+    private string updateLocationUrl;
     private PluginManager pluginManager;
-    public InstallationManager() {
-      this.pluginDir = Path.GetFullPath(HeuristicLab.PluginInfrastructure.Properties.Settings.Default.PluginDir);
+    public InstallationManager(string pluginDir) {
+      this.pluginDir = pluginDir;
+      this.updateLocationUrl = "http://localhost:59253/UpdateLocation.svc";
       this.pluginManager = new PluginManager(pluginDir);
       this.pluginManager.DiscoverAndCheckPlugins();
@@ -19,9 +31,13 @@
     public IEnumerable<string> Show(IEnumerable<string> pluginNames) {
       foreach (PluginDescription desc in GetPluginDescriptions(pluginNames)) {
-        yield return ShowInformation(desc);
-      }
-    }
-
-    private string ShowInformation(PluginDescription desc) {
+        yield return GetInformation(desc);
+      }
+    }
+
+    internal string GetInformation(string pluginName) {
+      return GetInformation(GetPluginDescription(pluginName));
+    }
+
+    private string GetInformation(PluginDescription desc) {
       StringBuilder builder = new StringBuilder();
       builder.Append("Name: ").AppendLine(desc.Name);
@@ -46,24 +62,126 @@
         builder.AppendLine(dependent);
       }
+      builder.AppendLine("This plugin is " + desc.PluginState.ToString().ToLowerInvariant() + ".");
+      if (desc.PluginState == PluginState.Disabled) {
+        builder.AppendLine(DetermineProblem(desc));
+      }
 
       return builder.ToString();
     }
 
+    private static string DetermineProblem(PluginDescription desc) {
+      // either any file is missing
+      StringBuilder builder = new StringBuilder();
+      var missingFiles = from x in desc.Files
+                         where !File.Exists(x)
+                         select x;
+      if (missingFiles.Count() > 0) {
+        foreach (string fileName in desc.Files) {
+          if (!File.Exists(fileName)) builder.Append("Missing file: ").AppendLine(fileName);
+        }
+        return builder.ToString();
+      } else {
+        // or any dependency is disabled
+        var disabledDependencies = from x in desc.Dependencies
+                                   where x.PluginState == PluginState.Disabled
+                                   select x;
+        if (disabledDependencies.Count() > 0) {
+          foreach (var dependency in disabledDependencies) {
+            builder.Append(dependency.Name).AppendLine(" is disabled.").AppendLine(DetermineProblem(dependency));
+          }
+          return builder.ToString();
+        } else {
+          // or any dependency is missing / not installed
+          var declaredDependencies = GetDeclaredDependencies(desc);
+          if (declaredDependencies.Count() != desc.Dependencies.Count()) {
+            var missingDependencies = from x in declaredDependencies
+                                      where !desc.Dependencies.Any(dep => dep.Name == x)
+                                      select x;
+            builder.AppendLine("Necessary dependencies are missing:");
+            foreach (string missingDependency in missingDependencies) {
+              builder.AppendLine(missingDependency);
+            }
+          } else {
+            // or there was a problem loading the assemblies
+            builder.AppendLine("There was a problem while loading assemblies: ");
+            foreach (string assembly in desc.Assemblies) {
+              builder.AppendLine(assembly);
+            }
+            return builder.ToString();
+          }
+        }
+      }
+      return "There is an unknown problem with plugin: " + desc.Name;
+    }
+
+    private static IEnumerable<string> GetDeclaredDependencies(PluginDescription desc) {
+      var plugin = DefaultApplicationManager.GetInstances<IPlugin>(desc).Single();
+      return plugin.GetType().GetCustomAttributes(typeof(PluginDependencyAttribute), false).Cast<PluginDependencyAttribute>().Select(x => x.Dependency);
+    }
+
+    private PluginDescription GetPluginDescription(string pluginName) {
+      var exactMatch = from pluginDesc in pluginManager.Plugins
+                       where string.Equals(pluginName, pluginDesc.Name, StringComparison.InvariantCultureIgnoreCase)
+                       select pluginDesc;
+      var inexactMatch = from pluginDesc in pluginManager.Plugins
+                         where MatchPluginNameInexact(pluginName, pluginDesc.Name)
+                         select pluginDesc;
+      return exactMatch.Count() > 0 ? exactMatch.Single() : inexactMatch.First();
+    }
+
     private IEnumerable<PluginDescription> GetPluginDescriptions(IEnumerable<string> pluginNames) {
-      return from name in pluginNames
-             select (from pluginDesc in pluginManager.Plugins
-                     where name == pluginDesc.Name
-                     select pluginDesc).Single();
+      return from pluginName in pluginNames
+             select GetPluginDescription(pluginName);
+    }
+
+    private static bool MatchPluginNameInexact(string similarName, string actualName) {
+      return
+        // Core-3.2 == HeuristicLab.Core-3.2
+        actualName.Equals("HeuristicLab." + similarName, StringComparison.InvariantCultureIgnoreCase) ||
+        // HeuristicLab.Core == HeuristicLab.Core-3.2 (this should be save because we checked for exact matches first)
+        (Math.Abs(actualName.Length - similarName.Length) <= 4 && actualName.StartsWith(similarName, StringComparison.InvariantCultureIgnoreCase)) ||
+        // Core == HeuristicLab.Core-3.2
+        (Math.Abs(actualName.Length - similarName.Length) <= 17 && actualName.StartsWith("HeuristicLab." + similarName, StringComparison.InvariantCultureIgnoreCase));
     }
 
     public void Install(IEnumerable<string> pluginNames) {
-      throw new NotImplementedException();
+      IEnumerable<PluginInformation> pluginsToInstall;
+      using (UpdateLocationClient updateLocation = new UpdateLocationClient()) {
+        pluginsToInstall = from pluginName in pluginNames
+                               select GetMatchingPluginInformation(pluginName, updateLocation.GetAvailablePlugins());
+
+        var args = new PluginInfrastructureCancelEventArgs("Installing", pluginsToInstall);
+        OnPreInstall(args);
+        foreach (var pluginInfo in pluginsToInstall) {
+          var s = updateLocation.GetPackedPlugin(pluginInfo);
+          Console.WriteLine("Downloading: {0} {1} {2}", pluginInfo.Name, pluginInfo.Version, pluginInfo.BuildDate);
+        }
+      }
+      OnInstalled(new PluginInfrastructureEventArgs("Installed", pluginsToInstall));
+    }
+
+    private static PluginInformation GetMatchingPluginInformation(string pluginName, IEnumerable<PluginInformation> plugins) {
+      var exactMatch = from pluginDesc in plugins
+                       where string.Equals(pluginName, pluginDesc.Name, StringComparison.InvariantCultureIgnoreCase)
+                       select pluginDesc;
+      var inexactMatch = from pluginDesc in plugins
+                         where MatchPluginNameInexact(pluginName, pluginDesc.Name)
+                         select pluginDesc;
+      return exactMatch.Count() > 0 ? exactMatch.Single() : inexactMatch.First();
     }
 
     public void Remove(IEnumerable<string> pluginNames) {
-      foreach (PluginDescription pluginToDelete in PluginDescriptionIterator.IterateInDependencyOrder(GetPluginDescriptions(pluginNames))) {
-        foreach (string fileName in pluginToDelete.Files) {
-          Console.WriteLine("Deleting: " + Path.Combine(pluginDir, fileName));
-        }
+      var fileNames = from pluginToDelete in PluginDescriptionIterator.IterateDependentsTopDown(GetPluginDescriptions(pluginNames), pluginManager.Plugins)
+                      from fileName in pluginToDelete.Files
+                      select Path.Combine(pluginDir, fileName);
+      var args = new PluginInfrastructureCancelEventArgs("Deleting", fileNames);
+      OnPreDelete(args);
+      if (!args.Cancel) {
+        foreach (string fileName in fileNames) {
+          Console.WriteLine("Deleting file " + fileName);
+          // File.Delete(fileName);
+        }
+
+        OnDeleted(new PluginInfrastructureEventArgs("Deleted", fileNames));
       }
     }
@@ -72,4 +190,20 @@
       throw new NotImplementedException();
     }
+
+    private void OnPreDelete(PluginInfrastructureCancelEventArgs args) {
+      if (PreRemovePlugin != null) PreRemovePlugin(this, args);
+    }
+
+    private void OnDeleted(PluginInfrastructureEventArgs args) {
+      if (PluginRemoved != null) PluginRemoved(this, args);
+    }
+
+    private void OnPreInstall(PluginInfrastructureCancelEventArgs args) {
+      if (PreInstallPlugin != null) PreInstallPlugin(this, args);
+    }
+
+    private void OnInstalled(PluginInfrastructureEventArgs args) {
+      if (PluginInstalled != null) PluginInstalled(this, args);
+    }
   }
 }
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/Advanced/InstallationManagerConsole.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/Advanced/InstallationManagerConsole.cs	(revision 2517)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/Advanced/InstallationManagerConsole.cs	(revision 2517)
@@ -0,0 +1,78 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.PluginInfrastructure.Manager;
+using System.IO;
+using System.ComponentModel;
+
+namespace HeuristicLab.PluginInfrastructure.Advanced {
+  public class InstallationManagerConsole {
+    private InstallationManager installManager;
+    public InstallationManagerConsole() {
+      this.installManager = new InstallationManager(Path.GetFullPath(HeuristicLab.PluginInfrastructure.Properties.Settings.Default.PluginDir));
+      installManager.PreInstallPlugin += new EventHandler<PluginInfrastructureCancelEventArgs>(installManager_PreInstallPlugin);
+      installManager.PreRemovePlugin += new EventHandler<PluginInfrastructureCancelEventArgs>(installManager_PreRemovePlugin);
+      installManager.PreUpdatePlugin += new EventHandler<PluginInfrastructureCancelEventArgs>(installManager_PreUpdatePlugin);
+      installManager.PluginInstalled += new EventHandler<PluginInfrastructureEventArgs>(installManager_PluginInstalled);
+      installManager.PluginRemoved += new EventHandler<PluginInfrastructureEventArgs>(installManager_PluginRemoved);
+      installManager.PluginUpdated += new EventHandler<PluginInfrastructureEventArgs>(installManager_PluginUpdated);
+    }
+
+    void installManager_PreUpdatePlugin(object sender, PluginInfrastructureCancelEventArgs e) {
+      throw new NotImplementedException();
+    }
+
+    void installManager_PluginUpdated(object sender, PluginInfrastructureEventArgs e) {
+      throw new NotImplementedException();
+    }
+
+    void installManager_PreRemovePlugin(object sender, PluginInfrastructureCancelEventArgs e) {
+      Console.WriteLine("Following files are deleted:");
+      var fileNames = (IEnumerable<string>)e.Entity;
+      foreach (string fileName in fileNames) {
+        Console.WriteLine(fileName);
+      }
+      if (GetUserConfirmation()) e.Cancel = false;
+      else e.Cancel = true;
+      return;
+    }
+
+    void installManager_PluginRemoved(object sender, PluginInfrastructureEventArgs e) {
+      foreach (string fileName in (IEnumerable<string>)e.Entity)
+        Console.WriteLine("Deleted: {0}", fileName);
+    }
+
+    void installManager_PreInstallPlugin(object sender, PluginInfrastructureCancelEventArgs e) {
+      
+    }
+
+    void installManager_PluginInstalled(object sender, PluginInfrastructureEventArgs e) {
+      
+    }
+
+    private static bool GetUserConfirmation() {
+      Console.Write("Are you sure? (Y/n)");
+      string input = Console.ReadLine().ToUpperInvariant();
+      if (string.IsNullOrEmpty(input) || input == "Y") return true;
+      else return false;
+    }
+
+    public void Show(IEnumerable<string> pluginNames) {
+      foreach (string pluginName in pluginNames)
+        Console.WriteLine(installManager.GetInformation(pluginName));
+    }
+
+    public void Install(IEnumerable<string> pluginNames) {
+      installManager.Install(pluginNames);
+    }
+
+    public void Remove(IEnumerable<string> pluginNames) {
+      installManager.Remove(pluginNames);
+    }
+
+    public void Update(IEnumerable<string> pluginNames) {
+      installManager.Update(pluginNames);
+    }
+  }
+}
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/HeuristicLab.PluginInfrastructure.csproj
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/HeuristicLab.PluginInfrastructure.csproj	(revision 2516)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/HeuristicLab.PluginInfrastructure.csproj	(revision 2517)
@@ -82,8 +82,15 @@
     <Reference Include="System.Deployment" />
     <Reference Include="System.Drawing" />
+    <Reference Include="System.Runtime.Serialization">
+      <RequiredTargetFramework>3.0</RequiredTargetFramework>
+    </Reference>
+    <Reference Include="System.ServiceModel">
+      <RequiredTargetFramework>3.0</RequiredTargetFramework>
+    </Reference>
     <Reference Include="System.Windows.Forms" />
     <Reference Include="System.Xml" />
   </ItemGroup>
   <ItemGroup>
+    <Compile Include="Advanced\InstallationManagerConsole.cs" />
     <Compile Include="Advanced\InstallationManager.cs" />
     <Compile Include="Attributes\ApplicationAttribute.cs" />
@@ -103,4 +110,5 @@
     <Compile Include="InvalidPluginException.cs" />
     <Compile Include="Manager\ApplicationDescription.cs" />
+    <Compile Include="Manager\PluginInfrastructureCancelEventArgs.cs" />
     <Compile Include="Manager\DefaultApplicationManager.cs" />
     <Compile Include="Manager\PluginDescription.cs" />
@@ -135,8 +143,15 @@
       <LastGenOutput>Settings.Designer.cs</LastGenOutput>
     </None>
+    <None Include="Service References\UpdateLocationReference\UpdateLocation.xsd" />
+    <None Include="Service References\UpdateLocationReference\UpdateLocation1.xsd" />
     <Compile Include="Properties\Settings.Designer.cs">
       <AutoGen>True</AutoGen>
       <DependentUpon>Settings.settings</DependentUpon>
       <DesignTimeSharedInput>True</DesignTimeSharedInput>
+    </Compile>
+    <Compile Include="Service References\UpdateLocationReference\Reference.cs">
+      <AutoGen>True</AutoGen>
+      <DesignTime>True</DesignTime>
+      <DependentUpon>Reference.svcmap</DependentUpon>
     </Compile>
     <Compile Include="Starter\SplashScreen.cs">
@@ -159,4 +174,24 @@
     <Content Include="Resources\List.gif" />
     <Content Include="Resources\Logo_white.gif" />
+    <None Include="Service References\UpdateLocationReference\HeuristicLab.PluginInfrastructure.UpdateLocationReference.PluginInformation.datasource">
+      <DependentUpon>Reference.svcmap</DependentUpon>
+    </None>
+    <None Include="Service References\UpdateLocationReference\Reference.svcmap">
+      <Generator>WCF Proxy Generator</Generator>
+      <LastGenOutput>Reference.cs</LastGenOutput>
+    </None>
+    <None Include="Service References\UpdateLocationReference\configuration.svcinfo" />
+    <None Include="Service References\UpdateLocationReference\configuration91.svcinfo" />
+    <None Include="Service References\UpdateLocationReference\UpdateLocation.disco" />
+    <None Include="Service References\UpdateLocationReference\UpdateLocation.wsdl" />
+    <None Include="Service References\UpdateLocationReference\UpdateLocation2.xsd" />
+    <None Include="Service References\UpdateLocationReference\UpdateLocation3.xsd" />
+    <None Include="Service References\UpdateLocationReference\UpdateLocation4.xsd" />
+  </ItemGroup>
+  <ItemGroup>
+    <WCFMetadata Include="Service References\" />
+  </ItemGroup>
+  <ItemGroup>
+    <WCFMetadataStorage Include="Service References\UpdateLocationReference\" />
   </ItemGroup>
   <Import Project="$(MSBuildBinPath)\Microsoft.CSharp.targets" />
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/ICSharpCode.SharpZipLib License.txt
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/ICSharpCode.SharpZipLib License.txt	(revision 2517)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/ICSharpCode.SharpZipLib License.txt	(revision 2517)
@@ -0,0 +1,13 @@
+#ziplib (SharpZipLib, formerly NZipLib) is a Zip, GZip, Tar and BZip2 library written entirely in C# for the .NET platform. It is implemented as an assembly (installable in the GAC), and thus can easily be incorporated into other projects (in any .NET language). The creator of #ziplib put it this way: "I've ported the zip library over to C# because I needed gzip/zip compression and I didn't want to use libzip.dll or something like this. I want all in pure C#."
+
+License
+
+The library is released under the GPL with the following exception:
+
+Linking this library statically or dynamically with other modules is making a combined work based on this library. Thus, the terms and conditions of the GNU General Public License cover the whole combination.
+
+As a special exception, the copyright holders of this library give you permission to link this library with independent modules to produce an executable, regardless of the license terms of these independent modules, and to copy and distribute the resulting executable under terms of your choice, provided that you also meet, for each linked independent module, the terms and conditions of the license of that module. An independent module is a module which is not derived from or based on this library. If you modify this library, you may extend this exception to your version of the library, but you are not obligated to do so. If you do not wish to do so, delete this exception statement from your version.
+
+Note: The exception is changed to reflect the latest GNU Classpath exception. Older versions of #ziplib did have another exception, but the new one is clearer and it doesn't break compatibility with the old one.
+
+Bottom line: In plain English this means you can use this library in commercial closed-source applications.
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/Manager/ApplicationDescription.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/Manager/ApplicationDescription.cs	(revision 2516)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/Manager/ApplicationDescription.cs	(revision 2517)
@@ -37,5 +37,5 @@
     public string Name {
       get { return name; }
-      set { name = value; }
+      internal set { name = value; }
     }
     private Version version;
@@ -53,5 +53,5 @@
     /// Gets or sets the description of the application.
     /// </summary>
-    public string Description {
+    internal string Description {
       get { return description; }
       set { description = value; }
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/Manager/DefaultApplicationManager.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/Manager/DefaultApplicationManager.cs	(revision 2516)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/Manager/DefaultApplicationManager.cs	(revision 2517)
@@ -80,5 +80,5 @@
     private void LoadPlugins(IEnumerable<PluginDescription> plugins) {
       // load all loadable plugins (all dependencies available) into the execution context
-      foreach (var desc in PluginDescriptionIterator.IterateInDependencyOrder(plugins.Where(x => x.PluginState != PluginState.Disabled))) {
+      foreach (var desc in PluginDescriptionIterator.IterateDependenciesBottomUp(plugins.Where(x => x.PluginState != PluginState.Disabled))) {
         foreach (string assembly in desc.Assemblies) {
           var asm = Assembly.LoadFrom(assembly);
@@ -105,5 +105,5 @@
           plugin.OnUnload();
         }
-        foreach (var desc in PluginDescriptionIterator.IterateInDependencyOrder(plugins.Where(x => x.PluginState != PluginState.Disabled))) {
+        foreach (var desc in PluginDescriptionIterator.IterateDependenciesBottomUp(plugins.Where(x => x.PluginState != PluginState.Disabled))) {
           desc.Unload();
           OnPluginUnloaded(new PluginInfrastructureEventArgs("Plugin unloaded", desc));
@@ -134,5 +134,5 @@
     /// <typeparam name="T">Most general type.</typeparam>
     /// <returns>Enumerable of the created instances.</returns>
-    public IEnumerable<T> GetInstances<T>(IPluginDescription plugin) where T : class {
+    public static IEnumerable<T> GetInstances<T>(IPluginDescription plugin) where T : class {
       return from t in GetTypes(typeof(T), plugin)
              where !t.IsAbstract && !t.IsInterface && !t.HasElementType
@@ -155,5 +155,5 @@
     /// <typeparam name="T">Most general type.</typeparam>
     /// <returns>Enumerable of the created instances.</returns>
-    public IEnumerable<T> GetInstances<T>() where T : class {
+    public static IEnumerable<T> GetInstances<T>() where T : class {
       return from i in GetInstances(typeof(T))
              select (T)i;
@@ -165,5 +165,5 @@
     /// <typeparam name="type">Most general type.</typeparam>
     /// <returns>Enumerable of the created instances.</returns>
-    public IEnumerable<object> GetInstances(Type type) {
+    public static IEnumerable<object> GetInstances(Type type) {
       return from t in GetTypes(type)
              where !t.IsAbstract && !t.IsInterface && !t.HasElementType
@@ -176,5 +176,5 @@
     /// <param name="type">Most general type for which to find matching types.</param>
     /// <returns>Enumerable of the discovered types.</returns>
-    public IEnumerable<Type> GetTypes(Type type) {
+    public static IEnumerable<Type> GetTypes(Type type) {
       return from asm in AppDomain.CurrentDomain.GetAssemblies()
              from t in GetTypes(type, asm)
@@ -189,5 +189,5 @@
     /// <param name="plugin">The plugin the subtypes must be part of.</param>
     /// <returns>Enumerable of the discovered types.</returns>
-    public IEnumerable<Type> GetTypes(Type type, IPluginDescription pluginDescription) {
+    public static IEnumerable<Type> GetTypes(Type type, IPluginDescription pluginDescription) {
       PluginDescription pluginDesc = (PluginDescription)pluginDescription;
       return from asm in AppDomain.CurrentDomain.GetAssemblies()
@@ -225,4 +225,25 @@
       return null;
     }
+
+    #region IApplicationManager Members
+
+
+    IEnumerable<T> IApplicationManager.GetInstances<T>(IPluginDescription plugin) {
+      return GetInstances<T>(plugin);
+    }
+
+    IEnumerable<T> IApplicationManager.GetInstances<T>() {
+      return GetInstances<T>();
+    }
+
+    IEnumerable<Type> IApplicationManager.GetTypes(Type type) {
+      return GetTypes(type);
+    }
+
+    IEnumerable<Type> IApplicationManager.GetTypes(Type type, IPluginDescription plugin) {
+      return GetTypes(type, plugin);
+    }
+
+    #endregion
   }
 }
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/Manager/PluginDescription.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/Manager/PluginDescription.cs	(revision 2516)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/Manager/PluginDescription.cs	(revision 2517)
@@ -30,5 +30,5 @@
   /// </summary>
   [Serializable]
-  internal sealed class PluginDescription : IPluginDescription {
+  public sealed class PluginDescription : IPluginDescription {
     private int nTimesLoaded;
 
@@ -46,7 +46,7 @@
     /// Gets or sets the description of the plugin.
     /// </summary>
-    public string Description {
+    internal string Description {
       get { return description; }
-      internal set { description = value; }
+      set { description = value; }
     }
     private Version version;
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/Manager/PluginInfrastructureCancelEventArgs.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/Manager/PluginInfrastructureCancelEventArgs.cs	(revision 2517)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/Manager/PluginInfrastructureCancelEventArgs.cs	(revision 2517)
@@ -0,0 +1,39 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Text;
+using System.ComponentModel;
+
+namespace HeuristicLab.PluginInfrastructure.Manager {
+  // to be replaced by GenericEventArgs
+  [Serializable]
+  internal sealed class PluginInfrastructureCancelEventArgs : CancelEventArgs {
+    internal string Action { get; private set; }
+    internal object Entity { get; private set; }
+    internal PluginInfrastructureCancelEventArgs(string action, object entity)
+      : base() {
+      this.Action = action;
+      this.Entity = entity;
+    }
+  }
+}
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/Manager/PluginValidator.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/Manager/PluginValidator.cs	(revision 2516)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/Manager/PluginValidator.cs	(revision 2517)
@@ -218,5 +218,5 @@
 
       // minimal sanity check of the attribute values
-      if (!string.IsNullOrEmpty(pluginName) && !string.IsNullOrEmpty(pluginDescription) &&
+      if (!string.IsNullOrEmpty(pluginName) &&
           pluginFiles.Count > 0 &&
           pluginAssemblies.Count > 0 &&
@@ -250,9 +250,8 @@
           var matchingDescriptions = pluginDescriptions.Where(x => x.Name == pluginName);
           if (matchingDescriptions.Count() > 0) {
-            desc.AddDependency(matchingDescriptions.First());
+            desc.AddDependency(matchingDescriptions.Single());
           } else {
             // no plugin description that matches the dependency name is available => plugin is disabled
             desc.Disable();
-            break; // stop processing more dependencies
           }
         }
@@ -279,5 +278,5 @@
     private void LoadPlugins(IEnumerable<PluginDescription> pluginDescriptions) {
       // load all loadable plugins (all dependencies available) into the execution context
-      foreach (var desc in PluginDescriptionIterator.IterateInDependencyOrder(pluginDescriptions
+      foreach (var desc in PluginDescriptionIterator.IterateDependenciesBottomUp(pluginDescriptions
                                                                                 .Where(x => x.PluginState != PluginState.Disabled))) {
         List<Type> types = new List<Type>();
